//
//  SMInterfaceInspectorServer.h
//  InterfaceInspectorServer
//
//  Created by Stephan Michels on 03.04.13.
//  Copyright (c) 2013 Stephan Michels. All rights reserved.
//

#import <Foundation/Foundation.h>

@class SMService;

@interface SMInterfaceInspectorServer : NSObject {
	SMService *_service;
	NSMutableArray *_connectedServers;
	BOOL _started;
	BOOL _selectionMode;
	NSMutableDictionary *_overlayWindows;
}

@property (nonatomic, getter = isStarted, readonly) BOOL started;

+ (instancetype)sharedInstance;

- (void)start;
- (void)stop;

@end

__attribute__((constructor))
static void initialize_InterfaceInspectorServer() {
	SMInterfaceInspectorServer *server = [SMInterfaceInspectorServer sharedInstance];
	if (!server.started) {
		[server start];
	}
}

__attribute__((destructor))
static void destroy_InterfaceInspectorServer() {
	SMInterfaceInspectorServer *server = [SMInterfaceInspectorServer sharedInstance];
	if (server.started) {
		[server stop];
	}
}